//+------------------------------------------------------------------+
//|                                               atr - walander.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Red

//
//
//
//
//

extern int    AtrDays = 3;
extern string AtrFrom = "08:00";
extern string AtrTo   = "17:00";

//
//
//
//
//

double atrBuffer[];
string st1,et1;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,atrBuffer);
         st1 = normalizeTime(AtrFrom);
         et1 = normalizeTime(AtrTo);
   return(0);
}

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMax(Bars-counted_bars,PERIOD_D1/Period());
           if (Period()>PERIOD_H4) return(0);

   //
   //
   //
   //
   //

   for(i = limit; i >= 0; i--)
   {
      atrBuffer[i] = atrBuffer[i+1];
         
      //
      //
      //
      //
      //
               
      int      d1Shift = iBarShift(NULL,PERIOD_D1,Time[i]);
      double   sum     = 0;
      for (int k=0; k<AtrDays; k++)
      {
         int    shift1  = iBarShift(NULL,0,iTime(NULL,PERIOD_D1,d1Shift-1));
         int    shift2  = iBarShift(NULL,0,iTime(NULL,PERIOD_D1,d1Shift));
         double min     = 999999999;
         double max     = 0;

            //
            //
            //
            //
            //
            
            if (d1Shift==0) shift1=-1;
            for (int n=shift2; n>shift1; n--)
            {
               datetime ts = StrToTime(TimeToStr(Time[n],TIME_DATE)+st1);
               datetime te = StrToTime(TimeToStr(Time[n],TIME_DATE)+et1);
               if (Time[n] >= ts && Time[n] < te)
                  {
                     min = MathMin(Low[n] ,min);
                     max = MathMax(High[n],max);
                  }
            }
            sum += (max-min); d1Shift++;
      }
      atrBuffer[i] = sum/AtrDays;
   }
   return(0);      
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string normalizeTime(string time)
{
   int sepAt  = StringFind(time,":",0);
   int hour   = StrToInteger(StringSubstr(time,0,sepAt));
   int minute = StrToInteger(StringSubstr(time,sepAt+1,0));
   
   //
   //
   //
   //
   //
   
   hour   = MathMax(MathMin(hour  ,24),0);
   minute = MathMax(MathMin(minute,59),0);
   string answer="";
      while(true)
      {
         if (hour==0) { answer="00";     break; }
         if (hour<10) { answer="0"+hour; break; }
                        answer=    hour; break; 
      }                        
      while(true)
      {
         if (minute==0) { answer=answer+":00";       break; }
         if (minute<10) { answer=answer+":0"+minute; break; }
                          answer=answer+":" +minute; break; 
      }
   return(" "+answer); 
}